<template>
  <v-container fluid ma-0 pa-2 white>
    <v-row class="mr-5 ml-1 mb-0 pb-0">
      <!-- <v-col cols="12" sm="1" md="1" class="mb-0 pb-0">
        <v-text-field
            v-model="team"
            :items="team"
            label="Team"
            hide-details
          ></v-text-field>
      </v-col> -->
      <v-col cols="12" sm="2" md="2" class="mb-0 pb-0">
          <v-select
            v-model="valueBoard.id"
            :items="itemsBoard"
            label="Board Name"
            item-text="name"
            item-value="id"
            return-object
            hide-details
            @change="boardChange()"
          ></v-select>
      </v-col>
      <v-col cols="12" sm="3" md="3" class="mb-0 pb-0">
        <v-select
            v-model="valueProject.key"
            :items="itemsProject"
            label="Project Name"
            item-text="name"
            item-value="key"
            multiple
            hide-details
            return-object
          ></v-select>
      </v-col>
      <v-col cols="12" sm="2" md="2" class="mb-0 pb-0">
        <v-menu
          ref="menu"
          v-model="menu"
          :close-on-content-click="false"
          :return-value.sync="date"
          transition="scale-transition"
          offset-y
          hide-details
          min-width="auto"
        >
          <template v-slot:activator="{ on, attrs }">
            <v-text-field
              v-model="date"
              label="Start Date"
              prepend-icon="mdi-calendar"
              readonly
              v-bind="attrs"
              v-on="on"
              hide-details
            ></v-text-field>
          </template>
          <v-date-picker v-model="date" no-title scrollable>
            <v-spacer></v-spacer>
            <v-btn text color="primary" @click="menu = false"> Cancel </v-btn>
            <v-btn text color="primary" @click="$refs.menu.save(date)">
              OK
            </v-btn>
          </v-date-picker>
        </v-menu>
      </v-col>
      <v-col cols="12" sm="2" md="2" class="mb-0 pb-0">
        <v-menu
          ref="menu2"
          v-model="menu2"
          :close-on-content-click="false"
          :return-value.sync="date2"
          transition="scale-transition"
          offset-y
          min-width="auto"
          hide-details
        >
          <template v-slot:activator="{ on, attrs }">
            <v-text-field
              v-model="date2"
              label="End Date"
              prepend-icon="mdi-calendar"
              readonly
              v-bind="attrs"
              v-on="on"
              hide-details
            ></v-text-field>
          </template>
          <v-date-picker v-model="date2" no-title scrollable>
            <v-spacer></v-spacer>
            <v-btn text color="primary" @click="menu2 = false"> Cancel </v-btn>
            <v-btn text color="primary" @click="$refs.menu2.save(date2)">
              OK
            </v-btn>
          </v-date-picker>
        </v-menu>
      </v-col>
      <v-col cols="12" sm="1" md="1" class="mb-0 pb-0">
        <v-text-field
          v-model="efforJsonList.jiraDev"
          counter="50"
          hint="Jira ticket"
          label="Jira ticket"
          @keydown="$event.keyCode === 13 ? getWorklogByTicket() : false"
          hide-details
        ></v-text-field>
      </v-col>
      <v-col cols="12" sm="2" md="2" class="pt-5 text-right ma-0 pa-0 btn-inline">
        <v-btn color="success" @click="getWorklogs()"> Search</v-btn>
        <v-btn color="warning" @click="chartKPI()"> Chart KPI</v-btn>
      </v-col>
      
    </v-row>
    <!-- member -->
    <!-- <v-row>
      <v-col cols="12" sm="12" md="12">
        <v-select
          v-model="member.userName"
          :items="itemsMember"
          label="Members"
          item-text="displayName"
          item-value="userName"
          multiple
          hide-details
          return-object
        ></v-select>
      </v-col>
    </v-row> -->
    <v-row v-show="false" class="mb-0 pb-0">
      <v-col cols="12" sm="3" md="3">
        <v-text-field
          v-model="efforJsonList.userName"
          counter="100"
          hint="User Name"
          label="User Name (*)"
        ></v-text-field>
      </v-col>
      <v-col cols="12" sm="3" md="3">
        <v-text-field
          v-model="efforJsonList.pwd"
          counter="50"
          type="password"
          hint="Passsword (*)"
          label="Passsword"
        ></v-text-field>
      </v-col>
      
    </v-row>
<!-- 
    <v-row class="mt-0 mb-0 pb-0">
      <v-col class="mt-0 mb-0 pb-0">
        <div style="color:red">[KPI sheet] Only copy columns: CLT Ticket,CLV Ticket,Task Received Date,Assigner,Assignee,Team,Project,Module,Short Description,Task Type,Estimated Effort,Actual Effort,Effort Date,Plan Start,Plan Finish</div>
        
      </v-col>
    </v-row> -->

    <v-row class="mt-0 mb-0 pb-0">
      <v-col cols="12" sm="9" md="9" class="">
        <h3 class="bold">Working days[{{this.workCount}}] [CLV/Total:{{this.strMemberTotalCLV}}/{{this.strMemberTotal}} - KPI:{{this.sKPICLV.toFixed(1)}} ({{this.sWloadPercent.toFixed(2)}}%)]: [{{this.strMemberEffort}}]</h3>
      </v-col>
      <v-col cols="12" sm="2" md="2" class="text-right">
        <v-checkbox
          v-model="isChangeHour"
          label="Change hour/week"
          hide-details
        ></v-checkbox>
      </v-col>
      <v-col cols="12" sm="1" md="1" class="ma-0 pb-0 pt-0">
        <v-text-field
          v-model="totalHourWeek"
          hint="Total hour / Week"
          label="Total hour / Week"
          class="text-right"
          suffix="hour/week"
          :disabled="!isChangeHour"
          hide-details
        ></v-text-field>
      </v-col>
      <v-col cols="12" sm="12" md="12" class="pt-0">
        <hot-table ref="hotTableComponent" :settings="hotSettings"> </hot-table>
      </v-col>
    </v-row>
    
    <v-row class="mb-0 pb-0 mt-0 pt-0">
      <v-col cols="6" sm="6" md="6" class="mb-0 pb-0 mt-0 pt-0">
        <v-col cols="12" sm="10" md="10" class="mb-0 pb-0">
          <h4>Ticket <span style="color:red"> {{this.jiraIdSeleted}}: {{this.jiraIdTotalHour}}h ({{this.jiraIdTotalHour*25}} point) : {{this.jiraIdStatus}}</span>
          <br/>
          <span> {{this.jiraIdTotalHourDetail}}</span>
          </h4>
        </v-col>
        <v-col cols="12" sm="2" md="2" class="mb-0 pb-0 mt-0 pt-0">
          <!-- <v-btn color="warning" @click="exportCSV()" :disabled='true'> Export CSV</v-btn> -->
          <!-- var exportPlugin1 = hot1.getPlugin('exportFile'); -->
        </v-col>
        <v-col cols="12" sm="12" md="12">
          <!-- <vue-json-editor 
              :expandedOnStart="true"
              :value='ticketJson'
              mode='code'
              >
            </vue-json-editor> -->
            <hot-table ref="hotTableComponentWorkLog" :settings="hotSettingsLWorkLog"> </hot-table>
          </v-col>
      </v-col>
      <v-col cols="6" sm="6" md="6" class="mb-0 pb-0">
        <div id="chart">
          <apexchart type="line" height="350" :options="chartOptions" :series="series"></apexchart>
        </div>
      </v-col>
    </v-row>
    <v-overlay :value="overlay">
      <v-progress-circular
        indeterminate
        size="64"
      ></v-progress-circular>
    </v-overlay>
  </v-container>
</template>
<script>
import axios from "axios";
import moment from "moment";
import momentBiz from 'moment-business-days';
import config from "../../../config/config";
// import VueJsonPretty from "vue-json-pretty";
// import "vue-json-pretty/lib/styles.css";
import cookieClient from "vue-cookie";
import vueJsonEditor from "vue-json-editor";
import { HotTable } from "@handsontable-pro/vue";
import Handsontable from "handsontable";
// import '~handsontable/dist/handsontable.full.css'
import "handsontable-pro/dist/handsontable.full.css";

export default {
  components: {
    // VueJsonPretty,
    HotTable,
    vueJsonEditor,
    // Loading,
  },
  data() {
    const self = this;
    return {
      date: new Date().toISOString().substr(0, 10),
      date2: new Date().toISOString().substr(0, 10),
      menu: false,
      menu2: false,
      clvKPI: [],
      kpiMonthLbl1: [],
      team: "Smartlink",
      projectsName: "SPKA",
      valueBoard: {},
      itemsBoard: [],
      valueProject:{},
      itemsProject: [],
      isBtnDisable: false,
      ticketJson: [],
      jiraLinkRoot:
        "https://pim.cyberlogitec.com/jira/rest/clt-gadget/latest/getWorklogByUser.json?",
      jiraLink: "",
      userName:"",
      pwd: "",
      jiraDev:"",
      member: {},
      //startdate=2021-04-01&enddate=2021-04-30&projects=SPKA,
      itemsMember: [
        {
          userName: 'doudevnn',
          displayName: 'Nam Nguyen Ngoc OLD'
        },
        {
          userName: 'nam.nguyenngoc',
          displayName: 'Nam Nguyen Ngoc'
        },
        {
          userName: '203737',
          displayName: 'Dung cao'
        },
        {
          userName: '203728',
          displayName: 'Khanh Nguyen'
        },
      ],
      efforJsonList: {
        jiraLink: "",
        userName:"",
        pwd: "",
        jiraDev:"",
        from: this.date,
        to: this.date2,
        // projectsName: "SmartLink [Internal]",
        month: 5,
        week: 10,
        year: 2021,
        NAM: {
          member: "Nam Nguyen Ngoc",
          account: "nam.nguyenngoc",
          jiraLog: [],
          jiraTicketByTimeH: [],
          total: {},
        },
        NAM2: {
          member: "Nam Nguyen Ngoc OLD",
          account: "doudevnn",
          jiraLog: [],
          jiraTicketByTimeH: [],
          total: {},
        },
        DUNG: {
          member: "Dung Cao",
          account: "203737",
          jiraLog: [],
          jiraTicketByTimeH: [],
          total: {},
        },
        KHANH: {
          member: "Khanh Nguyen",
          account: "203728",
          jiraLog: [],
          jiraTicketByTimeH: [],
          total: {},
        },
      },
      pimDATA: [],
      hotSettings: {
        copyPaste: true,
        // data: this.pimDATA,
        startRows: 1000,
        startCols: 15,
        stretchH: "all",
        autoWrapRow: true,
        height: 360,
        maxRows: 1000,
        rowHeaders: true,
        colHeaders: true,
        filters: true,
        multiColumnSorting: true,
        columns: [
          {
            data: "jiraId",
            width: 60,
          },
          {
            data: "cLTTicket",
            width: 90,
            className: "htCenter",
          },
          {
            data: "cLVTicket",
            width: 70,
            className: "htCenter",
          },
          {
            data: "taskReceivedDate",
            type: 'date',
            dateFormat: 'YYYY-MM-DD',
            correctFormat: true,
            sortOrder: 'desc',
            width: 110,
            className: "htCenter",
          },
          {
            data: "assigner",
            width: 140,
          },
          {
            data: "assignee",
            width: 140,
          },
          {
            data: "team",
            width: 90,
          },
          {
            data: "project",
          },
          {
            data: "module",
            width: 110,
          },
          {
            data: "shortDescription",
          },
          {
            data: "taskType",
            width: 110,
          },
          {
            data: "estimatedEffort",
            width: 90,
          },
          {
            data: "actualEffort",
            text: "right",
            width: 90,
          },
          {
            data: "effortDate",
            type: 'date',
            dateFormat: 'YYYY-MM-DD',
            correctFormat: true,
            sortOrder: 'desc',
            width: 110,
          },
          {
            data: "planStart",
            width: 90,
          },
          {
            data: "planFinish",
            width: 90,
          },{
            data: "status",
            width: 120,
          },{
            data: "picName",
            width: 120,
          },
        ],
        colHeaders: [
          "jiraId",
          "CLT Ticket",
          "CLV Ticket",
          "Receive Date",
          "Assigner",
          "Assignee",
          "Team",
          "Project",
          "Module",
          "Short Description",
          "Task Type",
          "Estimated Effort",
          "Actual Effort",
          "Effort Date",
          "Plan Start",
          "Plan Finish",
          "Status",
          "Dev"
        ],
        multiColumnSorting: {
          sortEmptyCells: true,
          initialConfig: [ {
            column: 12,
            sortOrder: 'desc'
          }]
        },
        contextMenu: true,
        dropdownMenu: ['filter_by_condition', 'filter_action_bar', 'filter_by_value'],
        language: "en-US",
        afterChange: () => {},
        afterOnCellMouseDown: function afterOnCellMouseDown(_, coords) {
            var cell = this;
            if(coords.row != -1 && coords.col != -1){
              console.log('value', cell.getValue());
              let selected = cell.getSelected();
              if(selected != undefined && selected[0][1] == 0){
                let data = cell.getData();
                let jiraID = cell.getValue();
                self.getWorklogByTicketOfline(cell.getSourceData(), data, jiraID);
              }
              if(selected != undefined && selected[0][1] == 1){
                self.routerLink(cell.getValue());
              }
            }
        }

      },
      hotSettingsLWorkLog: {
        copyPaste: true,
        // data: this.pimDATA,
        startRows: 1000,
        startCols: 15,
        stretchH: "all",
        autoWrapRow: true,
        height: 230,
        maxRows: 1000,
        rowHeaders: true,
        colHeaders: true,
        filters: true,
        multiColumnSorting: true,
        columns: [
          {
            data: "displayName",
            width: 160,
            
          },
          // {
          //   data: "userId",
          //   width: 90,
          //   hiddend: true,
          // },
          {
            data: "timeSpent",
            width: 90,
            className: "htRight",
          },
          {
            data: "point",
            width: 90,
            className: "htRight",
          },
          {
            data: "updated",
            width: 130,
          },
          {
            data: "comment",
          }
        ],
        colHeaders: [
          "DisplayName",
          // "UserId",
          "TimeSpent",
          "Point",
          "Updated",
          "Comment",
        ],
        multiColumnSorting: {
          sortEmptyCells: true,
          initialConfig: [ {
            column: 12,
            sortOrder: 'desc'
          }]
        },
        contextMenu: true,
        dropdownMenu: ['filter_by_condition', 'filter_action_bar', 'filter_by_value'],
        language: "en-US",
        afterChange: () => {
          // alert("a");
          // self.chartKPI();
        },
        // afterOnCellMouseDown: function () {
          //   var cell = this;
          //   console.log('value', cell.getValue());
          //   let selected = cell.getSelected();
          //   if(selected != undefined && selected[0][1] == 15){
          //     let data = cell.getData();
          //     let jiraID = cell.getValue();
          //     self.getWorklogByTicketOfline(data, jiraID);
          //   }
          // }
         

      },
      overlay: false,
      rowWorkLogs: [],
      jiraIdSeleted: "",
      jiraIdTotalHour: 0,
      jiraIdTotalHourDetail: "",
      jiraIdStatus: "",
      lstMember: [],
      strMemberTotal: 0,
      strMemberTotalCLV: 0,
      sKPICLV: 0.0,
      sWloadPercent: 0,
      strMemberEffort: "",
      dateList: [],
      //Chart start
      series: [],
      chartOptions: {
        chart: {
            height: 350,
            type: 'line',
        },
        stroke: {
            width: [0, 4]
        },
        title: {
            text: 'Resources Utilization Ratio'
        },
        dataLabels: {
            enabled: true,
            enabledOnSeries: [1,0]
        },
        labels: [],
        xaxis: {
            categories: [],
            labels: {
                style: {
                    colors: '#F1C40F'
                }
            },
            formatter: function (val) {
              return val + ' h'
            },
        },
        xaxis: {
            type: 'date',
            formatter: function (val) {
              return val + ' h'
            },
        },
        yaxis: [{
            title: {
            text: 'Actual Effort',
            },
            formatter: function (val) {
              return val + ' %'
            },
        
        }, {
            opposite: true,
            title: {
            text: 'Workload'
            }
        }]
    },
          
    //Chart end
    wordloadData: null,
    totalHourWeek: 40,
    isChangeHour: false,
    workCount: 0,
    };
  },
  created() {
    
    // this.getWorklogs();
    // this.jiraBoards();
    
    this.itemsBoard = JSON.parse(this.$cookies.get('boardList'));
    console.log("this.itemsBoard1", self.itemsBoard);
    console.log("this.itemsBoard", self.$cookies.get('boardList'));
    this.efforJsonList.userName = this.$cookies.get('userName');
    this.efforJsonList.pwd = this.$cookies.get('pwd');
    
    var startDate =  moment(new Date()).add((-1)*self.monthDifference, 'month').startOf('month');
      if(this.monthDifference <= 1){
          startDate =  moment().clone().startOf('month');
      }
      let endDate =  moment(new Date());
      let dateList = this.getDaysBetweenDates(startDate, endDate);
      for(var i = 0; i < dateList.length;  i++){
        this.chartOptions.labels.push(dateList[i]);
      }

  },
  mounted() {
    Array.prototype.sum = function (prop) {
        var total = 0
        for ( var i = 0, _len = this.length; i < _len; i++ ) {
            total += this[i][prop]
        }
        return total
    }
  },
  watch: {
    date(newVal) {
      // console.log('item changed', newVal);
      this.jiraLink = `https://pim.cyberlogitec.com/jira/rest/clt-gadget/latest/getWorklogByUser.json?startdate=${newVal}&enddate=${this.date2}&projects=${this.projectsName}`;
    },
    date2(newVal) {
      // console.log('item changed', newVal);
      this.jiraLink = `https://pim.cyberlogitec.com/jira/rest/clt-gadget/latest/getWorklogByUser.json?startdate=${this.date}&enddate=${newVal}&projects=${this.projectsName}`;
    },

    btnDisable(){
      // return true
      // if(this.efforJsonList.userName != undefined && this.efforJsonList.userName.trim().length > 0){
      // }
    },
    // kpiMonthLbl(value){
    //   console.log("aaaaaaaa");
    //   // self.kpiMonthLbl1 = ["2021-06-01", "2021-06-02"];
    // }
  },
  computed: {
     btnDisable: function () {
       // must parse because Vue turns empty value to string
      if(this.valueBoard.id != undefined 
        && !this.isBtnDisable){
         return false;
      }
      return true;
     },
     boardDisable: function () {
       // must parse because Vue turns empty value to string
      if(!this.isBtnDisable){
         return false;
      }
      return true;
     },
     kpiMonthLbl:function(){
      console.log("aaaaaaaa");
      return ["2021-06-01", "2021-06-02"];
    }
  },
  methods: {
    // kpiMonthLbl (){
    //   return ["2021-06-01", "2021-06-02"];
    // },
    workday_count(start, end) {
      var first = start.clone().endOf("week"); // end of first week
      var last = end.clone().startOf("week"); // start of last week
      var days = (last.diff(first, "days") * 5) / 7; // this will always multiply of 7
      var wfirst = first.day() - start.day(); // check first week
      if (start.day() == 0) --wfirst; // -1 if start with sunday
      var wlast = end.day() - last.day(); // check last week
      if (end.day() == 6) --wlast; // -1 if end with saturday
      var holidays = this.count_holiday(start, end);
      return wfirst + Math.floor(days) + wlast - holidays; // get the total
    }, //              ^ EDIT: if days count less than 7 so no decimal point
    count_holiday(start, end){
      let count = 0;
      while (start <= end) {
        console.log("start", start.format("YYYY-MM-DD"));
        if(config.holidays.find(({ holidayDate }) => holidayDate == start.format("YYYY-MM-DD"))){
          count++;
        }
        start = start.add(1, "days");
       
      }
      return count;
    },
    onJsonChange(value) {
      var ftest = { date: "2015-02-0", start: 1, end: 7 };
      var ltest = { date: "2015-02-2", start: 2, end: 8 };
      var f = "YYYY-MM-DD";
      var start = moment(ftest.date).add(-1,'days');
      var end = moment(ltest.date).add(1,'days');
      var wd = this.workday_count(start, end);
      console.log("valuewd:", wd);
      // this.efforJsonList.NAM.jiraTicketByTimeH = this.efforJsonList.NAM.jiraLog;
      if (undefined != value) {
        let ticket = null;
        let times = 0;
        this.efforJsonList.NAM.total = {};
        this.efforJsonList.NAM.jiraTicketByTimeH = [];
        for (var i = 0; i < value.issues.length; i++) {
          times += value.issues[i].Worklog / 60 / 60;
          ticket = {
            Issue: value.issues[i].Issue,
            Worklog: value.issues[i].Worklog / 60 / 60,
          };

          this.efforJsonList.NAM.jiraTicketByTimeH.push(ticket);

          //   console.log('valuedd:', this.efforJsonList.NAM.jiraLog.issues[i]);
          //  console.log('index:', i);
        }

        this.efforJsonList.NAM.total.countTicket =
          this.efforJsonList.NAM.jiraTicketByTimeH != undefined
            ? this.efforJsonList.NAM.jiraTicketByTimeH.length
            : 0;
        this.efforJsonList.NAM.total.times = times;
      }
    },

    getEffortJira() {
      this.$cookies.set(
        "crowd.cltems.token_key",
        "lqlZJuuqyynVh4KuuPqGWwAAAAAACYACZG91ZGV2bm4",
        "expiring time"
      );
      this.$cookies.set(
        "JSESSIONID",
        "C0D57CF498029BB85160DB217A0CCA7B",
        "expiring time"
      );
      this.$cookies.set(
        "atlassian.xsrf.token",
        "OX6K_db721eb8bbc90605be85a4afc21424a1def1ec59_lin",
        "expiring time"
      );
      // console.log("CK", this.$cookies.get("NID"));
      axios
        .get(this.jiraLink, {
          headers: {
            cookie:
              "crowd.cltems.token_key=lqlZJuuqyynVh4KuuPqGWwAAAAAACYACZG91ZGV2bm4; JSESSIONID=C0D57CF498029BB85160DB217A0CCA7B; atlassian.xsrf.token=OX6K_db721eb8bbc90605be85a4afc21424a1def1ec59_lin;",
          },
        })
        .then(function (response) {
          console.log("readfolder", response);
        });
    },
    async Insert(member) {
      let seft = this;
      this.efforJsonList.week = parseInt(seft.date.split("-")[1]);
      this.efforJsonList.month = parseInt(seft.date.split("-")[1]);
      this.efforJsonList.year = parseInt(seft.date.split("-")[0]);
      console.log(this.efforJsonList);
      await axios
        .post(config.API_JIRA + "/api/insertKPI", this.efforJsonList)
        .then(function (response) {});
    },
    async reloadBoard(){
      this.jiraBoards();
    },
    async jiraBoards(){
      const seft = this;
      seft.overlay = true;
      await axios
        .post(`${config.API_JIRA}/api/jiraBoards`, this.efforJsonList)
        .then(async function (response) {
          // seft.hotSettings.data = response.data.data;
          console.log('jiraBoards', response.data);
          // seft.pimDATA = response.data.data;
          seft.itemsBoard = response.data.data;
          seft.overlay = false;
        });
    },
    async boardChange(){
      const seft = this;
      seft.isBtnDisable = true;
      seft.overlay = true;
      this.efforJsonList.boardId = seft.valueBoard.id;
      await axios
        .post(`${config.API_JIRA}/api/jiraProjects`, this.efforJsonList)
        .then(async function (response) {
          // seft.hotSettings.data = response.data.data;
          console.log('itemsProject', response.data);
          // seft.pimDATA = response.data.data;
          seft.itemsProject = response.data.data;
          seft.isBtnDisable = false;
          seft.overlay = false;
        });
    },
    async getWorklogs() {
      const seft = this; //Current
      seft.isBtnDisable = true;
      seft.overlay = true;
      seft.$refs.hotTableComponent.hotInstance.loadData([]);
      this.efforJsonList.from =  this.date;
      this.efforJsonList.to = this.date2;
      this.efforJsonList.itemsProject = this.itemsProject;
      this.efforJsonList.team = this.team;
      // this.projectsName = 'SmartLink [Internal]'
      this.efforJsonList.itemsMember = this.member;

      //Count working day
      let countWD = this.workday_count(moment(this.date), moment(this.date2));
      this.workCount = countWD;
      console.log("countWD",countWD);
      await axios
        .post(`${config.API_JIRA}/api/jiraWorklogs`, this.efforJsonList)
        .then(async function (response) {
          // seft.hotSettings.data = response.data.data;
          // console.log('pimDATA', seft.pimDATA);
          // seft.pimDATA = response.data.data;
          //lstMember
          let data = response.data.data;
          let lsMemberNames = [
              {
                  id: 'nam.nguyenngoc',
                  name: 'Nam Nguyen Ngoc',
                  total: 0
              },
              {
                  id: 'doudevnn',
                  name: 'Nam Nguyen Ngoc OLD',
                  total: 0
              },
              {
                  id: '203737',
                  name: 'Dung Cao',
                  total: 0
              },
              {
                  id: '203728',
                  name: 'Khanh Nguyen',
                  total: 0
              },
            ];
          let lsCLV = [
            {
                  id: 'nam.nguyenngoc',
                  email: 'nam.nguyenngoc@cyberlogitec.com',
              },
              {
                  id: '203737',
                  email: 'dung.cao@cyberlogitec.com',
              },
              {
                  id: '203728',
                  email: 'khanh.vn@cyberlogitec.com',
              },
          ]

          if(data != undefined && data.length > 0){
            //Total
            let flagMember = "";
            let total;
            seft.strMemberTotalCLV = 0;
            seft.strMemberTotal = 0;
            self.sKPICLV = 0;
            let emailSeen = new Set();

            //Get email
            for(var i = 0; i < data.length; i++){
              // data[i].assignee;
              emailSeen.add(data[i].emailAddress);
            }
            let userTotal = [];
            for(var i = 0; i < data.length; i++){
              // data[i].assignee;
              // emailSeen.add(data[i].emailAddress);
              for(let email of emailSeen){
                
                if(data[i].emailAddress == email){
                  
                  let user = userTotal.find( ({ email }) => email  === data[i].emailAddress);
                  if(user != undefined && user != null){
                      user.total += data[i].actualEffort;
                  }else{
                    userTotal.push({
                      email: data[i].emailAddress,
                      name: data[i].displayName,
                      total: data[i].actualEffort,
                    })
                  }
                }
              }
              // if(data[i].emailAddress == "nam.nguyenngoc@cyberlogitec.com"){
              //   lsMemberNames[0].total += data[i].actualEffort;
              // }
              // else if(data[i].assignee == "Dung Cao"){
              //   lsMemberNames[1].total += data[i].actualEffort;
              // }else if(data[i].assignee == "Khanh Nguyen"){
              //   lsMemberNames[2].total += data[i].actualEffort;
              // }
              
              // if(lsMemberNames.find( ({ name }) => name === data[i].assignee)){
              //   seft.strMemberTotalCLV += data[i].actualEffort;

              // }
              if(lsCLV.find( ({ email }) => email  === data[i].emailAddress)){
                seft.strMemberTotalCLV += data[i].actualEffort; //Need to check

              }
              seft.strMemberTotal += data[i].actualEffort;
              

            }
            console.log("userTotal", userTotal);
            seft.sKPICLV = seft.strMemberTotalCLV/(countWD*8);
            seft.sWloadPercent = (seft.strMemberTotalCLV / (countWD * lsCLV.length * 8))*100;
            // console.log('KPICLV', self.sKPICLV.toFixed(1));
            let hWeek = countWD*8;
            if(seft.isChangeHour == true){
              hWeek = seft.totalHourWeek;
            }
            seft.strMemberEffort = userTotal.map(mem => `${mem.name}:${mem.total}(${Math.round(((mem.total/parseInt(hWeek))*100))}%)`).join(', ');
            // console.log("lsMemberNames", lsMemberNames.map(mem => `${mem.name}:${mem.total}`).join(', '));
            console.log("hWeek", hWeek);
            console.log("self.isChangeHour", self.isChangeHour);
            self.wordloadData = data;
            console.log("wordloadData", self.wordloadData);
            
            await seft.$refs.hotTableComponent.hotInstance.loadData(
              data
            );

                      
          }else{
            
          }
          seft.isBtnDisable = false;
          seft.overlay = false;

          
          // seft.$refs.hotTableComponent.hotInstance.loadData(seft.pimDATA);
        }).catch((error) => {
            if( error.response ){
                console.log(error.response.data); // => the response payload 
                seft.isBtnDisable = false;
                seft.overlay = false;
            }
        });
    },
    async getWorklogByTicket(){
      const seft = this;
      seft.isBtnDisable = true;
      seft.overlay = true;
      this.efforJsonList.boardId = seft.valueBoard.id;
      this.efforJsonList.ticketid = this.efforJsonList.jiraDev;
      this.jiraIdSeleted = this.efforJsonList.jiraDev;
      this.jiraIdTotalHourDetail = "";
      await axios
        .post(`${config.API_JIRA}/api/getIssueWorklogs`, this.efforJsonList)
        .then(async function (response) {
          // seft.hotSettings.data = response.data.data;
          console.log('itemsProject', response.data);
          // seft.pimDATA = response.data.data;
          seft.isBtnDisable = false;
          seft.ticketJson =  response.data;
          seft.overlay = false;

          console.log("getWorklogByTicket");
          seft.$refs.hotTableComponentWorkLog.hotInstance.loadData([]); 
          let seen = new Set();
          let arrayDisplay = [];
          let logs = response.data.data;
          let ticket = response.data.tickets;
          let oneHour = 25; //Point
          if(logs != undefined && logs.length > 0){
            let arr = [];
            let total = 0;
            for(let i = 0; i < logs.length; i++){
              arr.push({
                "displayName": logs[i].author.displayName,
                "userId": logs[i].author.name,
                "timeSpent":logs[i].timeSpent,
                "point": parseFloat(logs[i].timeSpentSeconds/60/60) * oneHour,
                "updated": moment(logs[i].updated).format("YYYY-MM-DD HH:MM"),
                "comment": logs[i].comment,
              });
              total += logs[i].timeSpentSeconds;
              seen.add(logs[i].author.displayName);
            }

            //Tong tung nguoi
            for(let user of seen){
              let sum = 0;
              let sumP = 0;
              console.log("seen[j]", user);
              for(let i = 0; i < logs.length; i++){
                if(logs[i].author.displayName == user){
                  sum += logs[i].timeSpentSeconds;
                  sumP += parseFloat(logs[i].timeSpentSeconds/60/60) * oneHour;
                }
              }
              arrayDisplay.push({
                displayName: user,
                timeSpent: sum/60/60,
                point: sumP,
              });
            }
            seft.jiraIdTotalHour = total/60/60;
            seft.jiraIdTotalHourDetail = arrayDisplay.map(mem => `${mem.displayName}: ${mem.timeSpent}h (${mem.point})`).join(' | ');
            console.log("ticket", ticket.issues[0]);
            seft.jiraIdStatus = ticket.issues[0].fields.status.name;
            seft.$refs.hotTableComponentWorkLog.hotInstance.loadData(arr);
            console.log("getWorklogByTicket", arrayDisplay);
          }
          
        });
    },
    getWorklogByTicketOfline (sources, data, jiraId) {
        let oneHour = 25; //Point
      console.log("getWorklogByTicketOfline");
      this.$refs.hotTableComponentWorkLog.hotInstance.loadData([]); 
      this.jiraIdTotalHourDetail = "";
      let logDatas = sources.filter(function(item) { 
        return item.jiraId === jiraId; 
      });
      this.jiraIdSeleted = logDatas[0].key
      let logs = logDatas[0].worklogList;
      if(logs != undefined && logs.length > 0){
        let arr = [];
        let seen = new Set();
        let arrayDisplay = [];
        let total = 0;
        for(var i = 0; i < logs.length; i++){
          arr.push({
            "displayName": logs[i].author.displayName,
            "userId": logs[i].author.name,
            "timeSpent":logs[i].timeSpent,
            "point": parseFloat(logs[i].timeSpentSeconds/60/60) * oneHour,
            "updated": moment(logs[i].updated).format("YYYY-MM-DD HH:MM"),
            "comment": logs[i].comment,
          });
          total += logs[i].timeSpentSeconds;
          seen.add(logs[i].author.displayName);
        }
        for(let user of seen){
          let sum = 0;
          let sumP = 0;
          console.log("seen[j]", user);
          for(let i = 0; i < logs.length; i++){
            if(logs[i].author.displayName == user){
              sum += logs[i].timeSpentSeconds;
              sumP += parseFloat(logs[i].timeSpentSeconds/60/60) * oneHour;
            }
          }
          arrayDisplay.push({
            displayName: user,
            timeSpent: sum/60/60,
            point: sumP,
          });
        }
        this.jiraIdTotalHour = total/60/60;
        this.jiraIdTotalHourDetail = arrayDisplay.map(mem => `${mem.displayName}: ${mem.timeSpent}h (${mem.point})`).join(' | ');
        console.log("ticketo", logDatas);
        this.jiraIdStatus = logDatas[0].status;
        this.$refs.hotTableComponentWorkLog.hotInstance.loadData(arr);
        console.log("getWorklogByTicketOfline", logDatas[0].worklogList);
      }
    },
    routerLink(jiraTicket){
      let route = this.$router.resolve({path: `${config.PIM_URL}/${jiraTicket}`});
      // let route = this.$router.resolve('/link/to/page'); // This also works.
      window.open(`${config.PIM_URL}/${jiraTicket}`, '_blank');
    },
    getDaysBetweenDates(startDate, endDate) {
        var now = startDate.clone(), dates = [];
  
        while (now.isSameOrBefore(endDate)) {
            if(moment(now.format('YYYY-MM-DD'),'YYYY-MM-DD').isBusinessDay()){
              dates.push(now.format('YYYY-MM-DD'));

            }
            now.add(1, 'days');
        }
        return dates;
    },
    chartKPI(data){
        // let self = this;
        // var endDate = moment('2021-05-31');
        let lsMemberNames = [
            {
                id: 'nam.nguyenngoc',
                name: 'Nam Nguyen Ngoc',
                total: 0
            },
            {
                id: '203737',
                name: 'Dung Cao',
                total: 0
            },
            {
                id: '203728',
                name: 'Khanh Nguyen',
                total: 0
            },
        ];
        this.chartOptions.labels.splice(0);
        var startDate =  moment(this.date);
        let endDate =  moment(this.date2);
        let dateList = this.getDaysBetweenDates(startDate, endDate);
        let serWlogs = [];
        let serKPI = [];
        let countWD = this.workday_count(moment(this.date), moment(this.date2));
        console.log("data", self.wordloadData);
        console.log("find", lsMemberNames.find( ({ id }) => id === '203728'));
        console.log("find", lsMemberNames.find( ({ id }) => id === '2037281'));
        for(var i = 0; i < dateList.length;  i++){
          this.chartOptions.labels.push(dateList[i]);
          // lsMemberNames.map(mem => `${mem.name}
          let dataTotal = self.wordloadData.filter(function (item) {
            if (lsMemberNames.find( ({ id }) => id === item.name) != undefined
                  && item.effortDate === dateList[i]) return true
          });
          serWlogs.push(dataTotal.sum('actualEffort'));
          
          serKPI.push(Math.round((dataTotal.sum('actualEffort')/(lsMemberNames.length*8))*100));
          // console.log("dataTotal: " +dateList[i], dataTotal.sum('actualEffort'));
        }

        
        
        //Data
        let series = [{
            name: 'ActEffort',
            type: 'column',
            data: serWlogs
            }, {
            name: 'Workload',
            type: 'line',
            data: serKPI
        }];
        this.series = series;
        console.log("chartOptions", this.chartOptions);
        
        // this.chartOptions.xaxis.categories.push("aaaaaaaa");
        // this.chartOptions.xaxis.categories.,.text = 'Jira KPI MONTH';
        // this.chartOptions.labels = [];
        // this.chartOptions.labels = this.getDaysBetweenDates(startDate, endDate);
        // this.chartOptions.updateSeries([{
        //     labels: self.getDaysBetweenDates(startDate, endDate),
        //     }])
      
    },
    
  },
};

</script>
<style scoped>
  .v-data-table {
    width: 100%;
  }
  .v-top {
    vertical-align: top;
  }
  .v-data-table tr td {
    vertical-align: top;
  }
  .v-data-table tr:hover,
  .v-data-table tbody tr:hover:not(.v-data-table__expanded__content) {
    background: #fff !important;
  }
  .menu__content{
    z-index: 9999 !important;
  }
  .v-overlay--active{
    z-index: 9999 !important;
  }

  .btn-inline{
    display: flex;
  }
  .btn-inline button{
    flex: 1 1 auto;
    margin-right: 4px !important;
  }
  .btn-inline button:first-child{
    flex-grow: 1;
  }
  #ofBar {
  display: none !important;
}
</style>
